Draft Move/en: Difference between revisions

From FreeCAD Documentation
No edit summary
(Updating to match new version of source page)
(21 intermediate revisions by 4 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand|Name=Draft_Move|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft -> Move|Shortcut=M V}}
{{Docnav|[[Draft_Label|Label]]|[[Draft_Rotate|Rotate]]|[[Draft_Module|Draft]]|IconL=Draft_Label.svg|IconC=Workbench_Draft.svg|IconR=Draft_Rotate.svg}}

{{GuiCommand
|Name=Draft Move
|MenuLocation=Draft → Move
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Shortcut={{KEY|M}} {{KEY|V}}
|SeeAlso=[[Draft Array]], [[Draft PathArray]]
|Version=0.7
}}


==Description==
==Description==


The Move tool moves or copies the selected objects from one point to another on the current [[Draft Workingplane|work plane]]. If no object is selected, you will be invited to select one.
The Move tool moves or copies the selected objects from one point to another.

The Move tool can be used on 2D shapes created with the [[Draft Workbench]] or [[Sketcher Workbench]], but can also be used on many types of 3D objects such as those created with the [[Part Workbench]] or [[Arch Workbench]].

To produce various copies in different arrangements use [[Draft Array]], [[Draft PathArray]] and [[Draft PointArray]].


[[Image:Draft_Move_example.jpg|400px]]
[[Image:Draft_Move_example.jpg|400px]]
{{Caption|Moving an object from one point to another point}}


==How to use==
==How to use==


# Select objects you wish to move or copy
# Select the objects that you wish to move or copy.
# Press the {{KEY|[[Image:Draft Move.png|16px]] [[Draft Move]]}} button, or press {{KEY|M}} then {{KEY|V}} keys
# Press the {{Button|[[Image:Draft Move.svg|16px]] [[Draft Move]]}} button, or press {{KEY|M}} then {{KEY|V}} keys. If no object is selected, you will be invited to select one.
# Click a first point on the 3D view, or type a [[Draft_Coordinates|coordinate]]
# Click a first point on the 3D view, or type a [[Draft_Coordinates|coordinate]] and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button. This serves as the base point of the operation.
# Click another point on the 3D view, or type a [[Draft_Coordinates|coordinate]]
# Click another point on the 3D view, or type a [[Draft_Coordinates|coordinate]] and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button. This is the new position of the base point.


==Opciones==
===Limitations===
When moving an object that is based on a [[Sketcher Sketch]], for example, a feature created with the [[PartDesign Workbench]] ([[PartDesign Pad|Pad]], [[PartDesign Revolution|Revolution]], etc.) you must move the original sketch. If you move the derived object, it will just go back to the position defined by the sketch.


==Options==
* Presiona {{KEY|X}}, {{KEY|Y}} o {{KEY|Z}} después de un punto para restringir el siguiente punto sobre el eje indicado.

* Para introducir coordenadas manualmente, simplemente introduce los números y presiona {{KEY|ENTER}} entre cada componente X, Y y Z.
* Press {{KEY|X}}, {{KEY|Y}} or {{KEY|Z}} after a point to constrain the next point on the given axis.
* Presiona {{KEY|R}} o selecciona la casilla para activar/desactivar el botón {{KEY|'''Relativas'''}}. Si está activado el modo relativas, las coordenadas del siguiente punto son relativas al punto anterior. En otro caso, son absolutas, tomadas desde el origen de coordenadas (0,0,0).
* To enter coordinates manually, simply enter the numbers, then press {{KEY|Enter}} between each X, Y and Z component. You can press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button when you have the desired values to insert the point.
* Presiona {{KEY|T}} o selecciona la casilla para activar/desactivar el botón {{KEY|'''Continuar'''}}. Si el modo continuar está activado, la herramienta mover se reiniciará después de terminar, permitiendo mover o copiar los objetos otra vez sin volver a pulsar el botón de Mover.
* Press {{KEY|R}} or click the checkbox to toggle ''relative'' mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
* Presionando {{KEY|ALT}} o {{KEY|C}} o seleccionando el botón {{KEY|'''Copy'''}} se creará una copia de los objetos, en lugar de moverlos. Si mantienes la tecla {{KEY|ALT}} pulsada después de designar el segundo punto, serás capaz de ubicar más copias, hasta que liberes la tecla {{KEY|ALT}}.
* Press {{KEY|T}} or click the checkbox to toggle ''continue'' mode. If continue mode is on, the Move tool will restart after you finish the operation, allowing you to move or copy the objects again without pressing the tool button again.
* Presiona {{KEY|CTRL}} mientras dibujas para forzar el [[Draft_Snap/es|ajuste]] de tu punto a la ubicación de ajuste más cercana, independientemente de la distancia.
* Press {{KEY|P}} or click the checkbox to toggle ''copy'' mode. If copy mode is on, the Move tool will keep the original shape in its place but will make a copy at the second point.
* Presiona {{KEY|SHIFT}} mientras dibujas para [[Draft_Constrain/es|restringir]] tu siguiente punto horizontal o verticalmente en relación con el último.
:You can use both {{KEY|T}} and {{KEY|P}} to place several copies in sequence. In this case, the duplicated element is the last placed copy.
* Presiona {{KEY|ESC}} o el botón {{KEY|'''Cancelar'''}} para abortar el comando actual.
* Hold {{KEY|Alt}} after the first point to also toggle copy mode. Keeping {{KEY|Alt}} pressed after clicking on the second point will allow you to continue placing copies; release {{KEY|Alt}} to finish the operation and see all copies.
* Hold {{KEY|Ctrl}} while moving to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Hold {{KEY|Shift}} while moving to [[Draft_Constrain|constrain]] your next point horizontally or vertically in relation to the last one.
* Press {{KEY|Esc}} or the {{button|Close}} button to abort the current command; copies already placed will remain.


==Scripting==
==Scripting==
{{emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].


The Move tool can by used in [[macros]] and from the python console by using the following function:
The Move tool can be used in [[macros]] and from the [[Python]] console by using the following function:


{{Code|code=
<syntaxhighlight>
movedlist = move(objectslist, vector, copy=False)
move (FreeCAD.Object or list, Vector, [copymode])
}}
</syntaxhighlight>


* Moves the given object or the objects contained in the given list in the direction and distance indicated by the given vector.
* Moves the base point of the objects in {{incode|objectslist}} by the displacement and direction indicated by {{incode|vector}}.
** {{incode|objectslist}} is either a single object or a list of objects.
* If copymode is True, the actual objects are not moved, but copies are created instead. Returns the object(s) (or their copies if copymode was True)
:The displacement vector is relative to the base point of the object, which means that if an object is moved 2 units, and then another 2 units, it will have moved 4 units in total from its original position.
* A list of the moved object (or the copies) is returned
* If {{incode|copy}} is {{incode|True}} copies are created instead of moving the original objects.
* {{incode|movedlist}} is returned with the original moved objects, or with the new copies.
** {{incode|movedlist}} is either a single object or a list of objects, depending on the input {{incode|objectslist}}.


Example:
Example:


{{Code|code=
<syntaxhighlight>
import FreeCAD,Draft
import FreeCAD, Draft
Draft.move(FreeCAD.ActiveDocument.ActiveObject,FreeCAD.Vector(2,2,0))
</syntaxhighlight>


Polygon1 = Draft.makePolygon(5, radius=1000)
<languages/>
Polygon2 = Draft.makePolygon(3, radius=500)
Polygon3 = Draft.makePolygon(6, radius=220)

Draft.move(Polygon1, FreeCAD.Vector(500, 500, 0))
Draft.move(Polygon1, FreeCAD.Vector(500, 500, 0))
Draft.move(Polygon2, FreeCAD.Vector(1000, -1000, 0))
Draft.move(Polygon3, FreeCAD.Vector(-500, -500, 0))

List1 = [Polygon1, Polygon2, Polygon3]

vector = FreeCAD.Vector(-2000, -2000, 0)
List2 = Draft.move(List1, vector, copy=True)
List3 = Draft.move(List1, -2*vector, copy=True)
}}

{{Docnav|[[Draft_Label|Label]]|[[Draft_Rotate|Rotate]]|[[Draft_Module|Draft]]|IconL=Draft_Label.svg|IconC=Workbench_Draft.svg|IconR=Draft_Rotate.svg}}

{{Draft Tools navi}}

{{Userdocnavi}}
{{clear}}

Revision as of 20:13, 11 February 2019

Draft Move

Menu location
Draft → Move
Workbenches
Draft, Arch
Default shortcut
M V
Introduced in version
0.7
See also
Draft Array, Draft PathArray

Description

The Move tool moves or copies the selected objects from one point to another.

The Move tool can be used on 2D shapes created with the Draft Workbench or Sketcher Workbench, but can also be used on many types of 3D objects such as those created with the Part Workbench or Arch Workbench.

To produce various copies in different arrangements use Draft Array, Draft PathArray and Draft PointArray.

Moving an object from one point to another point

How to use

  1. Select the objects that you wish to move or copy.
  2. Press the Draft Move button, or press M then V keys. If no object is selected, you will be invited to select one.
  3. Click a first point on the 3D view, or type a coordinate and press the add point button. This serves as the base point of the operation.
  4. Click another point on the 3D view, or type a coordinate and press the add point button. This is the new position of the base point.

Limitations

When moving an object that is based on a Sketcher Sketch, for example, a feature created with the PartDesign Workbench (Pad, Revolution, etc.) you must move the original sketch. If you move the derived object, it will just go back to the position defined by the sketch.

Options

  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component. You can press the add point button when you have the desired values to insert the point.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the Move tool will restart after you finish the operation, allowing you to move or copy the objects again without pressing the tool button again.
  • Press P or click the checkbox to toggle copy mode. If copy mode is on, the Move tool will keep the original shape in its place but will make a copy at the second point.
You can use both T and P to place several copies in sequence. In this case, the duplicated element is the last placed copy.
  • Hold Alt after the first point to also toggle copy mode. Keeping Alt pressed after clicking on the second point will allow you to continue placing copies; release Alt to finish the operation and see all copies.
  • Hold Ctrl while moving to force snapping your point to the nearest snap location, independently of the distance.
  • Hold Shift while moving to constrain your next point horizontally or vertically in relation to the last one.
  • Press Esc or the Close button to abort the current command; copies already placed will remain.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The Move tool can be used in macros and from the Python console by using the following function:

movedlist = move(objectslist, vector, copy=False)
  • Moves the base point of the objects in objectslist by the displacement and direction indicated by vector.
    • objectslist is either a single object or a list of objects.
The displacement vector is relative to the base point of the object, which means that if an object is moved 2 units, and then another 2 units, it will have moved 4 units in total from its original position.
  • If copy is True copies are created instead of moving the original objects.
  • movedlist is returned with the original moved objects, or with the new copies.
    • movedlist is either a single object or a list of objects, depending on the input objectslist.

Example:

import FreeCAD, Draft

Polygon1 = Draft.makePolygon(5, radius=1000)
Polygon2 = Draft.makePolygon(3, radius=500)
Polygon3 = Draft.makePolygon(6, radius=220)

Draft.move(Polygon1, FreeCAD.Vector(500, 500, 0))
Draft.move(Polygon1, FreeCAD.Vector(500, 500, 0))
Draft.move(Polygon2, FreeCAD.Vector(1000, -1000, 0))
Draft.move(Polygon3, FreeCAD.Vector(-500, -500, 0))

List1 = [Polygon1, Polygon2, Polygon3]

vector = FreeCAD.Vector(-2000, -2000, 0)
List2 = Draft.move(List1, vector, copy=True)
List3 = Draft.move(List1, -2*vector, copy=True)